
/*******************************************************************************
* Copyright (c) 2003 University Corporation for Advanced Internet
* Development (UCAID).
* All rights reserved.
*
* Permission is hereby granted, without written agreement and without
* license or royalty fees, to use, copy, modify, and distribute this
* software and its documentation for any purpose, provided that the
* above copyright notice appear in all software files.
*
* IN NO EVENT SHALL UCAID BE LIABLE TO ANY PARTY FOR * DIRECT, INDIRECT,
* SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE
* OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF UCAID HAS BEEN ADVISED
* OF THE POSSIBILITY OF SUCH DAMAGE.
*
* UCAID SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT LIMITED
* TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
* PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS"
* BASIS, AND UCAID HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT,
* UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*
*****************************************************************************/
#ifndef PRINT_INFO_HPP
#define PRINT_INFO_HPP

/** 
 * Class to be able to determine conditional constraints and allowed access 
 *  associated with a given user certificate.
 * @author Sushila R. Subramanian
 * @date  23 Feb 2003
 */

//using namespace Akenti;

class PrintInfo{
  
public:
  /* constructors */
  
  PrintInfo (); 

  /*  Print conditions after parsing them into individual conditions. */
  void getInfo (bool retval, CapabilityCertificate *cert, AkentiMessage *msg);

  /* Get Actions that are permitted unconditionally */
  string getActions ();

  /* Get actions that have unsatisfied constraint and associated attributes */
  string getConditionalInfo ();

private:
  
  string unConditionalActions;
  string conditionalInfo;
  
  void printAllowedActions (const vector <string>& allowedactions);

  void printAttributeInfos(const vector <AttributeInfo>& attrinfos);

  void printConstraints(const vector<ConditionalActions>& actions);
  /**
    * Helper function.
    */
  void printActions(const vector<string>& actions);
  
  /**
    * Helper function.
    */
  void printActions(const vector<Akenti::ConditionalActions>& actions);

};

#endif /* PRINT_CONDITIONS_HPP */
