#ifndef TESTEXTAUTH_HPP
#define TESTEXTAUTH_HPP

using namespace std;

namespace Akenti {

/** 
  * This class is a subclass of <i> ExternalEvaluator </i> and 
  * provides the support for a test case using EXT_AUTH type 
  * constraints.  It is a very simple case. It returns true 
  * whenever "TestExtAuth" is greater than 10 - which it will be
  * in our case.
  * 
  * @see ExternalEvaluator
  * @version 1.0 03/22/04
  * @author Sushila R. Subramanian
  *
  */

class TestExtAuth : public ExternalEvaluatorImpl {

public:

  /**
    * Default constructor 
    */
  TestExtAuth ();

  /**
    * Default destructor 
    */

  ~TestExtAuth ();

  /**
    * Returns <i>true</i> if this evaluator knows how to
    * handle the <i>EXT_AUTH attribute</i> specified in the
    * argument.
    *
    * @see evaluateExternalAttribute(TokenType, const AttributeInfo&)
    */

   bool canHandleExternalAttribute (const string & attribute);

  /**
    * Returns <i>true</i> if (attrInfo.getAttribute() op  attrInfo.getValue())
    *
    * Note: the engine will call this method only if
    *        canHandleHandleExternalAttribute<attrInfo.getAttribute()> returned
true.
    *
    * @see AttributeInfo
    * @see TokenType
    */
   bool evaluateExternalAttribute(TokenType op, const AttributeInfo& attrInfo);

};

} // end of name space

#endif /* TESTEXTAUTH_HPP */
