#include "AttributeCertGenerator.hpp"
#include "AttributeCertificateImpl.hpp"

namespace Akenti {

typedef AttributeCertGenerator ACG;

ACG::AttributeCertGenerator() 
  : AkentiCertGenerator(new AttributeCertificateImpl) { 
}

ACG::~AttributeCertGenerator() {
}

void
ACG::setPrincipal(const AkentiPrincipal& principal) {
  AttributeCertificateImpl* impl;
 
  impl = (AttributeCertificateImpl*) akentiCert.get();
  impl->setPrincipal(principal);
}

void
ACG::setAttribute(const string& attribute) {
  AttributeCertificateImpl* impl;
 
  impl = (AttributeCertificateImpl*) akentiCert.get();
  impl->setAttribute(attribute);
}

void
ACG::setValue(const string& value) {
  AttributeCertificateImpl* impl;

  impl = (AttributeCertificateImpl*) akentiCert.get();
  impl->setValue(value);
}

void
ACG::setCondition(const Condition& condition) {
  AttributeCertificateImpl* impl;

  impl = (AttributeCertificateImpl*) akentiCert.get();
  impl->setCondition(condition);
}

}

