#include "CapabilityCertGenerator.hpp"
#include "CapabilityCertificateImpl.hpp"

namespace Akenti {

typedef CapabilityCertGenerator CCG;

CCG::CapabilityCertGenerator() 
  : AkentiCertGenerator(new CapabilityCertificateImpl) {
}

CCG::~CapabilityCertGenerator() {
}

void 
CCG::setResource(const string& resource) {
  CapabilityCertificateImpl* 
    impl = (CapabilityCertificateImpl*) akentiCert.get();

  impl->setResource(resource);
}

void 
CCG::setPrincipal(const AkentiPrincipal& principal) {
  CapabilityCertificateImpl* 
    impl = (CapabilityCertificateImpl*) akentiCert.get();

  impl->setPrincipal(principal);
}

void 
CCG::setPublicKey(const PublicKey& publicKey) {
  CapabilityCertificateImpl* 
    impl = (CapabilityCertificateImpl*) akentiCert.get();
  
  impl->setPublicKey(publicKey);
}

void 
CCG::setUnConditionalActions(
  const vector<string>& unConditionalActions) {
  CapabilityCertificateImpl* 
    impl = (CapabilityCertificateImpl*) akentiCert.get();

  impl->setUnConditionalActions(unConditionalActions);
}

void 
CCG::setConditionalActions(
  const vector<ConditionalActions>& conditionalActions) {
  CapabilityCertificateImpl* 
    impl = (CapabilityCertificateImpl*) akentiCert.get();

  impl->setConditionalActions(conditionalActions);
}

const CapabilityCertificate&
CCG::generate() {
  return (const CapabilityCertificate&) akentiCert;
}

}
