#include "PolicyCertGenerator.hpp"
#include "PolicyCertificateImpl.hpp"

namespace Akenti {

typedef PolicyCertGenerator PCG;
typedef CertificateAuthorityInfo CAInfo;
typedef UseCondIssuerGroup UCGroup;

PCG::PolicyCertGenerator() 
  : AkentiCertGenerator(new PolicyCertificateImpl) {
}

PCG::PolicyCertGenerator(PolicyCertificateImpl* impl) 
  : AkentiCertGenerator(impl) {
}

PCG::~PolicyCertGenerator() {
}

void
PCG::setResource(const string& resource) {
  PolicyCertificateImpl* 
    impl = (PolicyCertificateImpl*) akentiCert.get();

  impl->setResource(resource);
}

void
PCG::setCertificateAuthorityInfos(const vector<CAInfo>& infos) {
  PolicyCertificateImpl*
    impl = (PolicyCertificateImpl*) akentiCert.get();

  impl->setCertificateAuthorityInfos(infos);
}

void 
PCG::setUseCondIssuerGroups(const vector<UCGroup>& ucGroups) {
  PolicyCertificateImpl* 
    impl = (PolicyCertificateImpl*) akentiCert.get();

  impl->setUseCondIssuerGroups(ucGroups);
}

void 
PCG::setAttributeDirectories(const vector<Directory>& dirs) {
  PolicyCertificateImpl* 
    impl = (PolicyCertificateImpl*) akentiCert.get();
   
  impl->setAttributeDirectories(dirs);
}

void
PCG::setCacheTime(long cacheTime) {
  PolicyCertificateImpl* 
    impl = (PolicyCertificateImpl*) akentiCert.get();

  impl->setCacheTime(cacheTime);
}

}
