#ifndef FILE_CERTIFICATE_RETRIEVAL_IMPL_HPP
#define FILE_CERTIFICATE_RETRIEVAL_IMPL_HPP

#include "CertificateRetrievalImpl.hpp"
#include "Filter.hpp"

using namespace Akenti;

namespace Akenti {

/**
  * Class to retrieve certificate from file.
  *
  * @see URL
  * @see CertificateRetrievalImpl
  * 
  * @version 1.1 00/05/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
class FileCertificateRetrievalImpl : public CertificateRetrievalImpl {

public:

  /**
    */
  FileCertificateRetrievalImpl();

  /**
    */
  virtual ~FileCertificateRetrievalImpl();


  /**
    */
  void
  getContent(const URL& url, 
             map<string, string>& args,
             vector<string>& results,
             string& enc) const;

protected:

  /**
    */
  virtual void 
  getContent(const URL& url, 
             const Filter& filter,
             vector<string>& results) const;

};

} // end of name space

#endif
