#include "ExternalEvaluatorImpl.hpp"
#include "AKRuntime.hpp"
#include "AttributeInfo.hpp"
#include "AKRuntime.hpp"

namespace Akenti {

typedef ExternalEvaluatorImpl EEI;

EEI::ExternalEvaluatorImpl() : cacheInterval(-1) ,akRuntime(NULL) {
}

EEI::~ExternalEvaluatorImpl() {
}

bool 
EEI::canHandleSystemAttribute(const string& attribute) {
  return false;
}
 
bool 
EEI::evaluateSystemAttribute(TokenType op, const AttributeInfo& attrInfo) {
  return false;
}

bool 
EEI::canHandleExternalAttribute(const string& attribute) {
  return false;
}

bool 
EEI::evaluateExternalAttribute(TokenType op, const AttributeInfo& attrInfo) {
  return false;
}

AKRuntime* 
EEI::getAKRuntime() {
  if (!akRuntime) {
    throw Error("ExternalEvaluatorImpl:getAKRuntime:illegal operation");
  }

  return akRuntime;
}

void 
EEI::setAKRuntime(AKRuntime* akRuntime) {
  this->akRuntime = akRuntime;
}

void 
EEI::setCacheInterval(int cacheInterval) {
  this->cacheInterval = cacheInterval;
}

int 
EEI::getCacheInterval() const {
  return cacheInterval;
}

const PolicyContext& 
EEI::getPolicyContext() {
  return getAKRuntime()->getPolicyContext();
}

CertificateVerifier& 
EEI::getCertificateVerifier() {
  return getAKRuntime()->getCertificateVerifier();
}

CertificateCache& 
EEI::getCertificateCache() {
  return getAKRuntime()->getCertificateCache();
}

}

