#include "ref_ptr.hpp"
#include "ExternalCache.hpp"
#include "Error.hpp"

namespace Akenti {

typedef ExternalCache EC;

ExternalCache EC::externalCache = ExternalCache();

EC::ExternalCache(ExternalCacheImpl* impl) 
  : ref_ptr<ExternalCacheImpl>(impl) {
}

void 
EC::setExternalCache(const ExternalCache& externalCache) {
  EC::externalCache = externalCache;
}

bool
EC::isExternalCacheSet() {
  return EC::externalCache != NULL;
}

ExternalCache& 
EC::getExternalCache() {
  if (!EC::externalCache) {
    throw Error(
      "ExternalCache:getExternalCache:external cache not set"
    );
  }

  return externalCache;
}

}
