#include <sstream> 
#include "CertInfo.hpp"
#include "Exception.hpp"

typedef CertInfo CI;

namespace Akenti {

CI::CertInfo() {
  hashCode = "dummy"; // default values
  resource = "NO_RESOURCE";
  type = "dummy";
  leaf = false;
  used = true;
  error = false;
}


CI::~CertInfo() {
}

CI::CertInfo (bool Used, AkentiCertificate cert, AkentiMessage mesg) {
  hashCode = "dummy"; // default values
  resource = "NO_RESOURCE";
  type = "dummy";
  used = true;
  leaf = false;
  error = false;
  setUsed (Used);
  addCert (cert);
  addMessage (mesg);
}

CI::CertInfo (bool Used, AkentiCertificate cert, AkentiMessage mesg,
       string Hash, string Type, string Resource) {
  used = true;
  leaf = false;
  error = false;
  setUsed (Used);
  addCert (cert);
  addMessage (mesg);
  setHashCode (Hash);
  setType (Type);
  setResource (Resource);
}

CI::CertInfo (bool Used, AkentiCertificate cert, AkentiMessage mesg,
       string Hash, string Type, string Resource, bool err) {
  used = true;
  leaf = false;
  setUsed (Used);
  addCert (cert);
  addMessage (mesg);
  setHashCode (Hash);
  setType (Type);
  setResource (Resource);
  setError (err);
}

void
CI::addMessage(AkentiMessage mesg) {
  statusMsgs.push_back (mesg);
}

void 
CI::addCert(AkentiCertificate cert) {
  akCert = cert;
}

void
CI::setUsed (bool usedVal) {
  if (used)
     used = usedVal; // so that if its set to false once; it doesnt become true
}

bool 
CI::getUsed () {
  return used;
}

void
CI::setError (bool err) {
  error = err;
}

bool 
CI::getError () {
  return error;
}

void
CI::setLeaf (bool leafVal) {
  leaf = leafVal;
}

bool 
CI::isLeaf () {
  return leaf;
}

const vector <AkentiMessage>&
CI::getMessages () {
  return  statusMsgs;
}

AkentiCertificate
CI::getCertificate () {
  return  akCert;
}

void
CI::setHashCode (string hcode) {
  hashCode = hcode;
}

string
CI::getHashCode () {
  return hashCode;
}

void
CI::setResource (string res) {
  resource = res;
}

string
CI::getResource () {
  return resource;
}

void
CI::setType (string ctype) {
  type = ctype;
}

string
CI::getType () {
  return type;
}

void
CI::setLocation (string slocation) {
  location = slocation;
}

string
CI::getLocation () {
  return location;
}

}
