#ifndef DUMMY_CERTIFICATE_IMPL_HPP
#define DUMMY_CERTIFICATE_IMPL_HPP

#include <vector>
#include "AkentiCertificateImpl.hpp"
#include "UseCondIssuerGroup.hpp"
#include "CertificateAuthorityInfo.hpp"


using std::vector;

namespace Akenti {

/**
  * The dummy certificate is used in <i>CertInfo</i> objects 
  * that must exist to hold catastrophic error messages that occur 
  * before any certificates are collected (e.g. Root policy certificate
  * doesnt exist or has an irrecoverable error).
  *
  * @see AkentiCertificate
  *
  * @version 1.0 04/05/20
  * @author Sushila R.Subramanian 
  **/

class DummyCertificateImpl : public AkentiCertificateImpl {

public:

  /**
    * Default Constructor.
    */
  DummyCertificateImpl();

  /**
    * Destroys this object.
    */
  ~DummyCertificateImpl();

}; 
 
} // end of name space

#endif
