#ifndef AKENTI_CHECK_ACCESS_RESPONSE_HPP
#define AKENTI_CHECK_ACCESS_RESPONSE_HPP

#include "AkentiResponse.hpp"
#include "CapabilityCertificate.hpp"

namespace Akenti {

/**
  * Used to wrap the response to a <i>CheckAccessRequest</i>.
  *
  * @see AkentiResponse
  * @see CheckAccessRequest
  */
class CheckAccessResponse : public AkentiResponse {
 
public:

  /**
    * Constuctor.
    */
  CheckAccessResponse();

  /**
    * Sets the user's <i>CapabilityCertificate</i>.
    *
    * @see CapabilityCertificate
    */
  void setCapabilityCertificate(const CapabilityCertificate& cert);

  /**
    * Returns the user's <i>CapabilityCertificate</i>.
    *
    * @see CapabilityCertificate
    */
  const CapabilityCertificate& getCapabilityCertificate() const;

private:

  friend class AkentiResponse;
  friend class AkentiRequestResponseImplFactory;
  static AkentiResponseImpl* getResponseImpl();
  class CheckAccessResponseImpl;
  typedef CheckAccessResponseImpl* ImplType;

};

}

#endif
