#include <sstream>
#include "HttpBase.hpp"
#include "IOException.hpp"

using std::ostringstream;
using std::istringstream;

namespace Akenti {

HttpBase::HttpBase() 
	: contentType("text/html"), protocol(PROTOCOL), obuff(NULL), contentLength(0) {
}

HttpBase::~HttpBase() {
}

void 
HttpBase::setProtocol(const string& protocol) {
  this->protocol = protocol;
}

const string& 
HttpBase::getProtocol() const {
  return protocol;
}

void 
HttpBase::setContentType(const string& contentType) {
  this->contentType = contentType;
}

const string&
HttpBase::getContentType() const {
  return contentType;
}

int
HttpBase::getContentLength() const {
  return contentLength;
}

InputStream 
HttpBase::getInputStream() const {
  return is; 
}

OutputStream 
HttpBase::getOutputStream() {
  if (!os) {
    os = obuff = new ostringstream();
  }
    
  return os;
}

void 
HttpBase::readLine(string& line, InputStream& is) const {
  line = is.getline();

  if (is->fail()) {
    throw IOException("HttpUtil:readLine:unable to parse request");
  }

  int len = line.length();

  if (len) {
    if (line[len - 1] == '\r') {
      line = line.substr(0, len - 1);
    }
  }
}

} // end of name space
