#ifndef AK_HTTP_URL_HANDLER_IMPL_HPP
#define AK_HTTP_URL_HANDLER_IMPL_HPP

#include "URLHandlerImpl.hpp"

/**
  * A <i>HttpURLHandlerImpl<i> object provides the services for an http URL 
  * that are not provided by the base class, URLHandlerImpl. These consist of
  * returning the default port of 80, and creating a HttpURLConnection.
  *
  * @see URLHandlerImpl
  * @see URL 
  * @see URLConnection
  *
  * @version 1.1 00/11/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
namespace Akenti {

class HttpURLHandlerImpl : public URLHandlerImpl {

public:

  /**
    * Constructs this object.
    */
  HttpURLHandlerImpl();

  /**
    * Destroys this object
    */  
  ~HttpURLHandlerImpl();

  /** 
    * Creates a  new the URL connection for the  specified url.
    *
    * @param  url the connection for this url  
    * @return the URL connection
    */
  URLConnection getURLConnection(const URL& url) const;

};

} // end of namespace Akenti

#endif
