#ifndef AK_SOCKET_INPUT_STREAM_HPP
#define AK_SOCKET_INPUT_STREAM_HPP

#include <iostream>

#if defined __GNUC__ && __GNUC__ < 3 
# include <streambuf.h>
#else 
# include <streambuf>
#endif 

using std::istream;
using std::streambuf;

/**
  * A <i>SocketInputStream</i> is subclass of istream.  Provides the input 
  * stream for the socket. 
  *
  * @version 1.1 00/11/01
  * @author Srilekha Mudumbai
  * @author Abdelilah Essiari
  */
namespace Akenti {

class SocketInputStream : public istream {

public:

  /**
    * Constructs this object.
    *
    * @param buf the input stream buffer
    */
  SocketInputStream(streambuf* buf) : istream(buf) {
  }

  /**
    * Destroys this object. 
    */
  ~SocketInputStream() {
    delete(rdbuf());
  }

};

} // end of namespace Akenti

#endif
