#ifndef OPEN_SSL_CIPHER_IMPL_HPP
#define OPEN_SSL_CIPHER_IMPL_HPP 

#include "CipherImpl.hpp"
#include "openssl/evp.h"

namespace Akenti {

/**
  *
  * @see CipherImpl
  * @see Cipher
  *
  * @author Abdelilah Essiari
  */
class OpenSSLCipherImpl : public CipherImpl {

public:

  /**
    */
  OpenSSLCipherImpl(const string& alg);

  /**
    */
  ~OpenSSLCipherImpl();

private:

  /**
    */
  void resetEngine();

  /**
    */
  string doUpdate(const string& data, int offset, int len);

  /**
    */
  string doDoFinal();

  /**
    */
  EVP_CIPHER_CTX ctx;

};

}

#endif
