#include "SSLConstants.hpp"

/**
 * Ciphers we are using.  Definitions here in SSLConstants.ccp to keep
 * Sun CC compiler happy. (Why these const vars are needed in the
 * first place, I'm not sure.  Seems like they are only used in the
 * CIPHERS[] anyway...)
 */
const char* const Akenti::SSLConstants::RSA_EXPORT1024_WITH_RC4_56_MD5      = "EXP1024-RC4-MD5";
const char* const Akenti::SSLConstants::RSA_EXPORT1024_WITH_RC2_CBC_56_MD5  = "EXP1024-RC2-CBC-MD5";
const char* const Akenti::SSLConstants::RSA_EXPORT1024_WITH_DES_CBC_SHA     = "EXP1024-DES-CBC-SHA";
const char* const Akenti::SSLConstants::DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA = "EXP1024-DHE-DSS-DES-CBC-SHA";
const char* const Akenti::SSLConstants::RSA_EXPORT1024_WITH_RC4_56_SHA      = "EXP1024-RC4-SHA";
const char* const Akenti::SSLConstants::DHE_DSS_EXPORT1024_WITH_RC4_56_SHA  = "EXP1024-DHE-DSS-RC4-SHA";
const char* const Akenti::SSLConstants::DHE_DSS_WITH_RC4_128_SHA            = "DHE-DSS-RC4-SHA";

/**
  * Having this array initialized here rather than in the header file
  *  was necessary in gcc 2.91. Later compilers allow it to be in the header
  */

const char* const 
Akenti::SSLConstants::CIPHERS[] = {
  RSA_EXPORT1024_WITH_RC4_56_MD5,
  RSA_EXPORT1024_WITH_RC2_CBC_56_MD5,
  RSA_EXPORT1024_WITH_DES_CBC_SHA,
  DHE_DSS_EXPORT1024_WITH_DES_CBC_SHA, 
  RSA_EXPORT1024_WITH_RC4_56_SHA,
  DHE_DSS_EXPORT1024_WITH_RC4_56_SHA,
  DHE_DSS_WITH_RC4_128_SHA, 
  (char *)0
};
