#include <string>
#include "Base64Util.hpp"

using namespace std;

namespace Akenti {

std::string 
Base64Util::format(const string& base64String){
  string ret;

  for (int i=0; i < base64String.size(); i++) {
    int val = (int) base64String.at(i);

    if (!(val >= (int) 'a' && val <= (int) 'z') &&
        !(val >= (int) 'A' && val <= (int) 'Z') &&
        !(val >= (int) '0' && val <= (int) '9') &&
        !(val == (int) '+' || val == (int) '/' || val == (int) '=') ) {
	continue;
    }

    ret += base64String.at(i);

    if (ret.size() % 65 == 64){
      ret += "\n";
    }
  }

  return ret;
}

std::string 
Base64Util::deformat(const string& base64String){
  string ret;

  for (int i=0; i < base64String.size(); i++) {
    int val = (int) base64String.at(i);

    if (!(val >= (int) 'a' && val <= (int) 'z') &&
        !(val >= (int) 'A' && val <= (int) 'Z') &&
        !(val >= (int) '0' && val <= (int) '9') &&
        !(val == (int) '+' || val == (int) '/' || val == (int) '=') ) {
	continue;
    }

    ret += base64String.at(i);
  }

  return ret;
}

}
