#include <map>
#include "LogInterface.hpp"
#include "Logger.hpp"

using namespace Akenti;

typedef LogInterface LI;

using std::map;

namespace Akenti {

static map<string, string> I_TABLE; 

static map<string, string> B_TABLE; 

static map<string, string> S_TABLE; 

static map<string, string> F_TABLE; 

static class Loader {

public:
  
  Loader() {
    I_TABLE["CHECK_ACCESS", " MSG=Checking Access"];
    F_TABLE["CHECK_ACCESS", " MSG=Access denied"];
    S_TABLE["CHECK_ACCESS", " MSG=Actions granted"];
  } 

} loader;

};

LI::LogInterface() {
}

LI::~LogInterface() {
}

void 
LI::iLog(int level, const string& key, const string& mesg) const {
  Logger::write(
     level,
     key,
     mesg + I_TABLE[key]
  );
}

void 
LI::bLog(int level, const string& key, const string& mesg) const {
  Logger::write(
    level,
    key,
    "STATUS=BEGIN " + mesg + B_TABLE[key]
  );
}

void 
LI::sLog(int level, const string& key, const string& mesg) const {
  Logger::write(
    level,
    key,
    "STATUS=SUCCESS " + mesg + S_TABLE[key]
  );
}

void 
LI::fLog(int level, const string& key, const string& mesg) const {
  Logger::write(
    level,
    key,
    "STATUS=FAIL " + mesg + F_TABLE[key]
  );
}
   
