#ifndef CAPABILITY_CERT_GENERATOR_TEST_CASE_HPP
#define CAPABILITY_CERT_GENERATOR_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Generates the capability certificates for the Akenti test.
  */
class CapabilityCertGeneratorTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object.
    */
  CapabilityCertGeneratorTestCase(const std::string& name = "CapabilityCertGeneratorTestCase")
    : TestCase (name) {
  }

  /**
    * Registers the <i>generateCapabilityCerts</i>.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Generates all the capability certificates used by
    * the akenti Test.
    */
  void generateCapabilityCerts();

  /**
   * Generate and test a capability certificate with no actions
   * or conditional actions
   */
  void generateCapabilityCert1();

  /**
   * Generate and test a capability certificate with some actions
   * and no conditional actions
   */
  void generateCapabilityCert2();

  /**
   * Generate and test a capability certificate with no actions
   * and some conditional actions
   */
  void generateCapabilityCert3();

  /**
   * Generate and test a capability certificate with some actions
   * and some conditional actions
   */
  void generateCapabilityCert4();
};

#endif
