#ifndef USE_COND_CERT_GENERATOR_TEST_CASE_HPP
#define USE_COND_CERT_GENERATOR_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Generates use-condition certificates for the 
  * Akenti test.
  *
  * @version 1.1 00/05/02
  * @author Willie Chin 
  * @author Abdelilah Essiari.
  */
class UseCondCertGeneratorTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object.
    */
  UseCondCertGeneratorTestCase(const std::string& name = "UseCondCertGeneratorTestCase") 
    : TestCase (name) {
  }

  /**
    * Registers the <i>generateUseCondCertificates</i>.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    */
  void generateUseCondCerts(); 

  /**
    */
  void generateROOT1UseCondCert();

  /**
    */
  void generateROOT2UseCondCert();

  /**
    */
  void generateSUB1UseCondCert();

  /**    
    */
  void generateSUB3UseCondCert();

  /**    
    */
  void generateSUB4UseCondCert();

  /**
    */
  void generateROOT3UseCondCert1();

  /**
    */
  void generateROOT3UseCondCert2();

  /**
    */
  void generateROOT4UseCondCert();

};

#endif

