#ifndef CERT_RETRIEVAL_TEST_CASE_HPP
#define CERT_RETRIEVAL_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Retrieves certificates from URL.
  */
class CertRetrievalTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this <i>TestCase</i>.
    */
  CertRetrievalTestCase(const std::string& name = "CertRetrievalTestCase") :
    TestCase(name) {
  }

  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

// private:

  /**
    * Calls the <i>testXXX</i> methods.
    */
  void doTest();

  /**
    */
  void testX509FileRetrieval();

  /**
    */
  void testUCFileRetrieval();

  /**
    */
  void testATTRFileRetrieval();

  /**
    */
  void testX509LdapRetrieval();

  /**
    */
  void testX509HttpRetrieval();

  /**
    */
  void testUCHttpRetrieval();

  /**
    */
  void testATTRHttpRetrieval();

};

#endif
