#include <iostream>
#include "cppunit/TextTestRunner.h"
#include "cppunit/TextTestResult.h"
#include "Provider.hpp"
#include "OpenSSLProviderImpl.hpp"
#include "CertRetrievalTestCase.hpp"
#include "Exception.hpp"
#include "Error.hpp"
#include "XMLUtil.hpp"

using namespace Akenti;
using namespace std;

int
main(int ac, char **argv) {
  try {
    Provider po = new OpenSSLProviderImpl;
    Provider::setProvider(po);
    
    po->loadDigestAlgorithms();
    XMLUtil::init();
    
    CppUnit::TextTestRunner runner;

    runner.addTest(CertRetrievalTestCase::suite());
    runner.run("", false);
    return 0;
  } catch(Exception& ex) {
    cout << "TestDirServices:main: " + ex.getMessage();
  } catch(Error& err) {
    cout << "TestDirServices:main:FATAL" + err.getMessage();
  }

  return 1; 
}
