#ifndef AKENTI_ENGINE_TEST_CASE_HPP   
#define AKENTI_ENGINE_TEST_CASE_HPP

#include "cppunit/TestCaller.h"
#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"
#include "ConditionalActions.hpp"

using namespace Akenti;

/**
  * 
  * @author Willie Chin
  * @author Abdelilah Essiari 
  */
class AkentiEngineTestCase : public CppUnit::TestCase
{
public:

  /**
    * Constructs this testcase.
    */ 
  AkentiEngineTestCase(const std::string& name = "AkentiEngineTestCase") 
    : TestCase (name) {
  }
    
  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    */
  void doTest();

  /**
    */ 
  void runROOT1Test();

  /**
    */ 
  void runROOT2Test();

  /**
    */
  void runSUB1Test(); 

  /**
    */
  void runSUB3Test(); 

  /**
    */
  void runSUB4Test(); 

  /**
    */ 
  void runROOT3Test();

  /**
    */ 
  void runROOT4Test();

  /**
    * Helper function.
    */
  void printActions(const vector<string>& actions);
  
  /**
    * Helper function.
    */
  void printActions(const vector<Akenti::ConditionalActions>& actions);

};

#endif
