#ifndef ENG_COMPONENT_TEST_CASE_HPP   
#define ENG_COMPONENT_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"
#include "AKRuntime.hpp"

/**
  * @author Abdelilah Essiari 
  * @author Jiewei Lin
  */
class EngComponentTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this testcase.
    */ 
  EngComponentTestCase(const std::string& name = "EngComponentTestCase") 
    : TestCase(name) {
  }
    
  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    *
    */
  void doTest();

  /**
    * Tests PolicyCollector if resource is at root level.
    *
    */ 
  void runPolicyColletorTest1(AKRuntime*);

  /**
    * Tests PolicyCollector if resource is at some levels down its root.
    *
    */ 
  void runPolicyColletorTest(AKRuntime*);

  /**
    * Tests CheckPolicyCollector i.e. the debug version of Policy Collector
    *
    */ 
  void runCheckPolicyCollectorTest(AKRuntime*);

  /**
    * Tests UseCondCollector. 
    *
    */ 
  void runUseCondColletorTest(AKRuntime*);

  /**
    * Tests CheckUseCondCollector i.e. the debug version of UseCondition 
    * Collector
    *
    */ 
  void runCheckUseCondCollectorTest(AKRuntime*);

  /**
    * Tests PolicyAuthorizer. 
    *
    */ 
  void runPolicyAuthorizerTest(AKRuntime*);

};

#endif
