#include <iostream>

#include <cppunit/TextTestRunner.h>
#include "AkentiEngineTestCase.hpp"
#include "../shared/TestCaseConstants.hpp"
#include "AkentiInit.hpp"
#include "Exception.hpp"
#include "Error.hpp"

#define DEBUG 0

using namespace std;

int
main(int ac, char **argv) {
  try {
    string status;
    bool init = Akenti::AkentiInit::init(CONF_DIR + CONF_FILE, status);

#if DEBUG 
    cout << status << endl;
#endif

    if (!init) {
      cout << "EngineTestFailed... bailing out" << endl;
      return 1;
    }

    CppUnit::TextTestRunner runner;

    runner.addTest(AkentiEngineTestCase::suite());
    runner.run("", false);
    return 0;
  } catch(Exception& ex) {
    cout << "TestPolicyEngine:main:" << ex << endl;
  } catch(Error& err) {
    cout << "TestPolicyEngine:main:" << err << endl;
  } 
}
