#include <iostream>

#include <cppunit/TextTestRunner.h>
#include "../../shared/TestCaseConstants.hpp"
#include "CacheTestCase.hpp"
#include "Provider.hpp"
#include "OpenSSLProviderImpl.hpp"
#include "XMLUtil.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace Akenti;
using namespace std;

int
main(int ac, char **argv) {
  try {
    Provider provider = Provider(new OpenSSLProviderImpl);

    provider->loadDigestAlgorithms();
    Provider::setProvider(provider);
    XMLUtil::init();
  
    CppUnit::TextTestRunner runner;

    runner.addTest(CacheTestCase::suite());
    runner.run("", false);
    return 0;
  } catch(Exception &ex) {
    cout << "TestCache:main:" << ex << endl;
  } catch(Error &err) {
    cout << "TestCache:main:" << err << endl;
  }
}
