#include <iostream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Xerces-Includes.hpp"
#include "GetResourceInfoRequestTestCase.hpp"
#include "GetResourceInfoRequest.hpp"
#include "AkentiRequests.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace std;
using namespace Akenti;

typedef GetResourceInfoRequestTestCase DCRTC;

void 
DCRTC::doTest() {
  string method;

  try {
    method = "GetResourceInfoRequestTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
DCRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif

  GetResourceInfoRequest ucr;
  string resource = "R1";

  ucr.setResource(resource);

  CPPUNIT_ASSERT(resource == ucr.getResource());

  AkentiRequests reqs;

  reqs.addRequest(ucr);

  string rep = reqs.toString();

#if DEBUG
  cout << rep << endl;
#endif

  DOMElement* element = reqs.toXML();

  reqs.fromXML(element);
  CPPUNIT_ASSERT(rep == reqs.toString());
  delete(element->getOwnerDocument());
  ucr = (GetResourceInfoRequest&) reqs.getRequestAt(0);
  CPPUNIT_ASSERT(resource == ucr.getResource());

#if DEBUG
  cout << "Exiting test1" << endl;
#endif
}

CppUnit::TestSuite*
DCRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("GetResourceInfoRequestTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<GetResourceInfoRequestTestCase> ( 
      "doTest", 
      &GetResourceInfoRequestTestCase::doTest
    )
  );

  return testSuite;
}
