#include <iostream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Xerces-Includes.hpp"
#include "GetResourceInfoResponseTestCase.hpp"
#include "GetResourceInfoResponse.hpp"
#include "AkentiResponses.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace std;
using namespace Akenti;

typedef GetResourceInfoResponseTestCase GRIRTC;

void 
GRIRTC::doTest() {
  string method;

  try {
    method = "GetResourceInfoResponseTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
GRIRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif

  GetResourceInfoResponse grir;

  string resourceInfo = "<action>read</action>";
  grir.setResourceInfo(resourceInfo);

  CPPUNIT_ASSERT(resourceInfo == grir.getResourceInfo());

  AkentiResponses resps;

  resps.addResponse(grir);

  string rep = resps.toString();

#if DEBUG
  cout << rep << endl;
#endif

  DOMElement* element = resps.toXML(); 

  resps.fromXML(element);
  delete(element->getOwnerDocument());
  CPPUNIT_ASSERT(rep == resps.toString());
  grir = (GetResourceInfoResponse&) resps.getResponseAt(0);
  CPPUNIT_ASSERT(resourceInfo == grir.getResourceInfo());

#if DEBUG
  cout << "Exiting test1" << endl;
#endif
}

CppUnit::TestSuite*
GRIRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("GetResourceInfoResponseTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<GetResourceInfoResponseTestCase> ( 
      "doTest", 
      &GetResourceInfoResponseTestCase::doTest
    )
  );

  return testSuite;
}
