#include <fstream>
#include <iostream>
#include <sstream>
#include "cppunit/Exception.h"
#include "cppunit/TestCaller.h"
#include "cppunit/Message.h"
#include "cppunit/SourceLine.h"
#include "Xerces-Includes.hpp"
#include "XMLUtil.hpp"
#include "ResourceBrowseRequestTestCase.hpp"
#include "ResourceBrowseRequest.hpp"
#include "AkentiRequests.hpp"
#include "Exception.hpp"
#include "Error.hpp"

using namespace std;

typedef ResourceBrowseRequestTestCase RBRTC;

void 
RBRTC::doTest() {
  string method;

  try {
    method = "ResourceBrowseRequestTestCase:doTest:test1:";
    test1();
  } catch (Exception& ex) {
    CppUnit::Message m(method + ex.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  } catch (Error& err) {
    CppUnit::Message m(method + err.getMessage());

    throw CppUnit::Exception(m, CPPUNIT_SOURCELINE());
  }
}

void
RBRTC::test1() {
#if DEBUG
  cout << "Entering test1! ..." << endl;
#endif
 
  AkentiRequests reqs;
  ResourceBrowseRequest req;
 
  reqs.addRequest(req);
 
  DOMElement* element = reqs.toXML();
 
#if DEBUG 
  XMLUtil::write(cout, element);
#endif
 
  reqs.fromXML(element);
  delete(element->getOwnerDocument());
 
#if DEBUG
  CPPUNIT_ASSERT(reqs.numOfRequests() == 1);
  cout << "Exiting test1! ..." << endl;
#endif

}

CppUnit::TestSuite*
RBRTC::suite() {
  CppUnit::TestSuite* testSuite = new CppUnit::TestSuite("ResourceBrowseRequestTestCase");

  testSuite->addTest (
    new CppUnit::TestCaller<ResourceBrowseRequestTestCase> ( 
      "doTest", 
      &ResourceBrowseRequestTestCase::doTest
    )
  );

  return testSuite;
}
