#ifndef BASE_64_TEST_CASE_HPP
#define BASE_64_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Tests the <i>Base64</i> class.
  *
  * @version  1.1 00/05/02
  * @author Willie Chin
  * @author Abdelilah Essiari 
  */
class Base64TestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object. 
    */
  Base64TestCase(const std::string& name = "Base64TestCase") 
    : TestCase(name) {
  }

  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Calls <i>test1</i> and <i>test2</i>.
    */
  void doTest();

  /**
    * Tests Base64 encoding and decoding.
    */
  void test1();

  /**
    * Tests Base64 encoding and decoding.
    */
  void test2();

};
 
#endif
