#ifndef INSTALL_RESOURCE_TREE_HPP
#define INSTALL_RESOURCE_TREE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

/**
  * Installs all the necessary directories used by the
  * Akenti test.
  */

class InstallResourceTree : public CppUnit::TestCase {

public: 

  /**
    * Constructs this object.
    */
  InstallResourceTree(const std::string& name = "InstallResourceTree") 
    : TestCase(name) {
  }

  /**
    * Registers the <i>createResourceTree</i>.
    */
  static CppUnit::TestSuite* suite();

// private:

  /**
    * Creates the resourceTree directory and all the 
    * sub directories. 
    */
  void createResourceTree(); 

  /**
    * Helper function.
    */
  void createDir(const std::string& dirName);

};

#endif
