#ifndef KEY_PAIR_TEST_CASE_HPP
#define KEY_PAIR_TEST_CASE_HPP

#include "cppunit/TestSuite.h"
#include "cppunit/TestCase.h"

class KeyPairTestCase : public CppUnit::TestCase {

public:

  KeyPairTestCase(const std::string& name = "KeyPairTestCase") : TestCase (name) {
  }

  /**
    * Registers the <i>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Calls generateRSAKeyPair and generateDSAKeyPair.
    */
  void doTest();

  /** 
    * Generates a RSA key pair, encode the keys in "DER", and finally decodes
    * them.
    */
  void generateRSAKeyPair();

  /** 
    * Generates a DSA key pair, encode the keys in "DER", and finally decodes
    * them.
    */
  void generateDSAKeyPair();

};

#endif
