#ifndef MESSAGE_DIGEST_TEST_CASE_HPP
#define MESSAGE_DIGEST_TEST_CASE_HPP

#include "cppunit/TestCase.h"
#include "cppunit/TestSuite.h"

/**
  * Tests the MessageDigest class,
  */
class MessageDigestTestCase : public CppUnit::TestCase {

public:

  /**
    * Constructs this object.
    */
  MessageDigestTestCase(const std::string& name = "MessageDigestTestCase") : TestCase(name) {
  }

  /**
    * Registers the <i<>doTest</i> method.
    */
  static CppUnit::TestSuite* suite();

private:

  /**
    * Calls <i>testMD5</i> and <i>testSHA1</i>.
    */
  void doTest();

  /**
    * Tests MD5 hashing algorithm.
    */
  void testMD5();

  /**
    * Tests SHA1 hashing algorithm.
    */
  void testSHA1();

};

#endif
