#include <iostream>
#include "Error.hpp" 

using std::ostream;

using Akenti::Error;

Error::Error(const string &message) : message(message) {
}

Error::~Error() throw() {
}

const string& 
Error::getMessage() const {
  return message;
}

const char * 
Error::what() const throw() {
  return getMessage().c_str();
}

string
Error::paramString() const {
  string params;
  
  params += '[';
  params += "message";   
  params += '=';
  params += '"';
  params += message;
  params += '"';
  params += ']';
  return params;
} 

ostream& 
operator<<(ostream& os, const Akenti::Error& exception) {
  os << exception.getMessage();
  return os;
}
