#include <iostream>
#include "Exception.hpp" 

using Akenti::Exception;

using std::ostream;

Exception::Exception(const string &message) : message(message) {
}

Exception::~Exception() throw() {
}

const string& 
Exception::getMessage() const {
  return message;
}

const char * 
Exception::what() const throw () {
  return getMessage().c_str();
}

string
Exception::paramString() const {
  string params;
  
  params += '[';
  params += "message";   
  params += '=';
  params += '"';
  params += message;
  params += '"';
  params += ']';
  return params;
} 

ostream& 
operator<<(ostream& os, const Akenti::Exception& exception) {
  os << exception.getMessage();
  return os;
}
