#include "SocketInBuffer.hpp"

typedef Akenti::SocketInBuffer SIB;

SIB::SocketInBuffer(const IOHandler& fd) : fd(fd) { 
  setg(
    buffer + PUSHBACK_SIZE,
    buffer + PUSHBACK_SIZE,
    buffer + PUSHBACK_SIZE
  );
}

SIB::~SocketInBuffer() {
}

string
SIB::paramString() const {
   return fd->paramString();
}

int
SIB::underflow() {
  if (gptr() < egptr()) {
    return *gptr();
  }

  int numPutback = gptr() - eback();

  if (numPutback > PUSHBACK_SIZE) {
    numPutback = PUSHBACK_SIZE;
  }

  memcpy(
    buffer + (PUSHBACK_SIZE - numPutback),
    gptr() - numPutback,
    numPutback
  );

  int num = fd->read(
    buffer + PUSHBACK_SIZE, 
    SOCKBUFF_SIZE - PUSHBACK_SIZE
  );

  if (num <= 0) {
    return EOF;
  }

  setg(
    buffer + (PUSHBACK_SIZE - numPutback),
    buffer + PUSHBACK_SIZE,
    buffer + PUSHBACK_SIZE + num
  );

  return *gptr();
}
