#include "OpenSSLPublicKeyImpl.hpp"

using Akenti::OpenSSLPublicKeyImpl;

OpenSSLPublicKeyImpl::OpenSSLPublicKeyImpl(EVP_PKEY* evp) 
  : OpenSSLKeyImpl(evp) {
}
  
EVP_PKEY*
OpenSSLPublicKeyImpl::getEVP_PKEY() {
  return evp;
}

string 
OpenSSLPublicKeyImpl::getAlgorithm() const {
  return algorithm();
}
  
string 
OpenSSLPublicKeyImpl::getFormat() const {
  return format();
}

int 
OpenSSLPublicKeyImpl::getSize() const { 
  return size();
}
  
string 
OpenSSLPublicKeyImpl::encrypt(const string &data) const {
  return publicEncrypt(data);
}

string 
OpenSSLPublicKeyImpl::decrypt(const string &encrypted) const {
  return publicDecrypt(encrypted);
}

string
OpenSSLPublicKeyImpl::paramString() const {
 string param;

 param = "[";
 param += "format=";
 param += getFormat();
 param += ",";
 param += "algorithm=";
 param += getAlgorithm();
 param += ",";
 param += "public";
 param += "]";
 return param;
}

