#ifndef OPEN_SSL_X509_CERTIFICATE_CHAIN_IMPL_HPP
#define OPEN_SSL_X509_CERTIFICATE_CHAIN_IMPL_HPP

#include <openssl/x509.h>
#include "CertificateChainImpl.hpp"

namespace Akenti {

class OpenSSLX509CertificateChainImpl : public CertificateChainImpl {

public:

  OpenSSLX509CertificateChainImpl(STACK_OF(X509) *chain);

  ~OpenSSLX509CertificateChainImpl();

  vector<Certificate> getCACertificates() const;

  void ignoreCertificates(const vector < pair<string,string> >& pairs);

  Certificate getSubjectCertificate() const;
  
  DistinguishedName getGuarantor() const;

  DistinguishedName getPrincipal() const;

  string paramString() const;

private:

  STACK_OF(X509) *chain;

  vector<int> ignoreIdxs;

};

} // end of namespace

#endif
