#include <sstream> 
#include "V3Extension.hpp"
#include "Error.hpp"

using Akenti::V3Extension;

V3Extension::V3Extension(int extnID, bool critical, const string& value_arg) 
  : extnID(extnID), critical(critical), value(value_arg) {
  
  // XXX is the id valid?
  if (!value_arg.size()) {
    throw Error("V3Extension:constuctor:illegal arg");
  }
}

V3Extension::~V3Extension() {
}

int
V3Extension::getExtensionID() const {
  return extnID;
}

bool
V3Extension::isCritical() const {
  return critical;
}

const string&
V3Extension::getValue() const {
  return value;
}

string 
V3Extension::paramString() const {
  std::ostringstream os;

  os << '['
     << "extID"
     << '='
     << getExtensionID() 
     << ','
     << "critical"
     << '='
     << isCritical()
     << ','
     << "value"
     << '='
     << '"'
     << getValue() 
     << '"'
     << ']';
  return os.str();
}
